# -*- coding: utf-8 -*-

import copy
import logging

from django_six import CompatibilityBaseCommand

from registration.models import (CourseRegisterFieldInfo, CourseRegisterFieldPoolInfo, CourseRegisterInfo,
                                 UserCourseRegisterInfo)


logger = logging.getLogger('console')


class Command(CompatibilityBaseCommand):
    def handle(self, *args, **options):

        logger.info('Hanyuan sync fields is dealing')

        fields = CourseRegisterFieldPoolInfo.objects.all()
        fields = {field.field_key: field.data for field in fields}
        print('>>> CourseRegisterFieldPoolInfo: ', fields, '\n')

        course_register_field_infos = CourseRegisterFieldInfo.objects.all()
        for course_register_field_info in course_register_field_infos:
            course_fields = course_register_field_info.fields
            new_course_fields = [fields.get(field.get('key')) or field for field in course_fields]
            print('>>> CourseRegisterFieldInfo: ', new_course_fields)
            if course_fields != new_course_fields:
                print('>>> CourseRegisterFieldInfo: Changed')
                course_register_field_info.fields = new_course_fields
                course_register_field_info.save()

        course_register_infos = CourseRegisterInfo.objects.all()
        for course_register_info in course_register_infos:
            course_fields = course_register_info.fields
            new_course_fields = [{**field, **fields.get(field.get('key'), {})} for field in course_fields]
            print('>>> CourseRegisterInfo: ', new_course_fields)
            if course_fields != new_course_fields:
                print('>>> CourseRegisterInfo: Changed')
                course_register_info.fields = new_course_fields
                course_register_info.save()

        user_course_register_infos = UserCourseRegisterInfo.objects.all()
        for user_course_register_info in user_course_register_infos:
            course_fields = user_course_register_info.fields
            new_course_fields = []
            for course_field in course_fields:
                course_fields_fields = course_field.get('fields') or []
                new_course_fields_fields = [{**field, **fields.get(field.get('key'), {})} for field in course_fields_fields]
                new_course_field = copy.deepcopy(course_field)
                new_course_field['fields'] = new_course_fields_fields
                new_course_fields.append(new_course_field)
            print('>>> UserCourseRegisterInfo: ', new_course_fields)
            if course_fields != new_course_fields:
                print('>>> UserCourseRegisterInfo: Changed')
                user_course_register_info.fields = new_course_fields
                user_course_register_info.save()
